version: '3.8'

services:
  api-service:
    container_name: api-$PROJECT_NAME
    image: node:16.14
    restart: unless-stopped
    depends_on:
      - database-service
    working_dir: /usr/src/app
    networks:
      default:
        aliases:
          - $API_HOSTNAME

  front-service:
    container_name: front-$PROJECT_NAME
    image: node:16.14
    restart: unless-stopped
    depends_on:
      - api-service
    networks:
      default:
        aliases:
          - $FRONT_HOSTNAME

  database-service:
    container_name: db-$PROJECT_NAME
    image: mongo:5.0.9
    restart: unless-stopped
    networks:
      default:
        aliases:
          - $MONGO_HOSTNAME


  haproxy-service:
    image: reverse-proxy-haproxy
    build:
      context: https://gitlab.com/projects-and-chill/who-am-i/haproxy-reverse-proxy.git#master
      dockerfile: Dockerfile
    container_name: haproxy-$PROJECT_NAME
    restart: unless-stopped
    depends_on:
      - api-service
      - front-service
    ports:
      - "80:80"
    environment:
      - API_PORT=$API_CONTAINER_PORT
      - FRONT_PORT=$FRONT_CONTAINER_PORT
      - REVPROXY_PORT=$REVPROXY_CONTAINER_PORT
      - API_HOSTNAME=$API_HOSTNAME
      - API_NAME=$API_NAME
      - FRONT_HOSTNAME=$FRONT_HOSTNAME
    networks:
      default:
        aliases:
          - $REVPROXY_HOSTNAME
